test_vmcd3.sh 1.58 KB
Newer Older
Timothy Stack's avatar
 
Timothy Stack committed
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85
#! /bin/sh

## Variables

# The full path of the test case
test_file=$1
# The base name of the test case
test_file_base="test_vmcd3.sh"
# The current test number for shell based tests.
test_num=0

# SRCDIR=@srcdir@
EMC_PORT=6565
VMC1_PORT=6566

## Helper functions

run_test() {
    echo "run_test: $*"
    $* > ${test_file_base}_${test_num}.tmp 2>&1
}

check_output() {
    diff -u - ${test_file_base}_${test_num}.tmp
    if test $? -ne 0; then
	echo $1
	exit 1
    fi
    test_num=`expr ${test_num} \+ 1`
}

##

# Start the daemons vmcd depends on:

../emc/emcd -l `pwd`/test_emcd.log \
    -i `pwd`/test_emcd.pid \
    -p ${EMC_PORT} \
    -s ops \
    -c `realpath ${SRCDIR}/test_emcd3.config`

vmc-client -l `pwd`/test_vmc-client1.log \
    -i `pwd`/test_vmc-client1.pid \
    -p ${VMC1_PORT} \
    -f ${SRCDIR}/test_vmcd3.pos \
    foobar

# Start vmcd:

vmcd -l `pwd`/test_vmcd.log \
    -i `pwd`/test_vmcd.pid \
    -e localhost \
    -p ${EMC_PORT} \
    -c localhost -P ${VMC1_PORT}

cleanup() {
    kill `cat test_vmcd.pid`
    kill `cat test_emcd.pid`
    kill `cat test_vmc-client1.pid`
}

trap 'cleanup' EXIT

sleep 2

newframe() {
    kill -s USR1 `cat test_vmc-client1.pid`
}

newframe

sleep 1

lpc=0
while test $lpc -lt 14; do
    newframe
    sleep 0.1
    lpc=`expr $lpc + 1`
done

run_test ../mtp/mtp_send -n localhost -P ${EMC_PORT} \
    -r emulab -i 1 -c 0 -m "empty" init -- \
    -w -i 1 request-position

check_output "no update?" <<EOF
Timothy Stack's avatar
 
Timothy Stack committed
86
Packet: version 2; role emc
Timothy Stack's avatar
 
Timothy Stack committed
87 88
 opcode:	update-position
  id:		1
Timothy Stack's avatar
 
Timothy Stack committed
89 90 91
  x:		6.000000
  y:		5.280000
  theta:	-3.141593
Timothy Stack's avatar
 
Timothy Stack committed
92
  status:	-1
Timothy Stack's avatar
 
Timothy Stack committed
93
  timestamp:	14.000000
Timothy Stack's avatar
 
Timothy Stack committed
94
EOF